#include<windows.h>

#define ID_BUTTON1 1
#define ID_EDIT1 2
#define ID_STATIC 3
#define ID_CHECKBOX 4
#define ID_BUTTON2 5

// Step 4: the Window Procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HWND hButton1, hButton2, hCheckBox, hEdit, hStatic;
	static HMENU hMenu, hSubMenu;

	switch (msg)
	{
	case WM_CREATE:
		hButton1 = CreateWindowEx(0, L"BUTTON", L"Zmie kolor ta", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			5, 5, 150, 30, 
			hwnd, (HMENU)ID_BUTTON1, ((LPCREATESTRUCT)lParam)->hInstance, 0);
		hButton2 = CreateWindowEx(0, L"BUTTON", L"Ustaw nazw okna", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
			5, 40, 150, 30,
			hwnd, (HMENU)ID_BUTTON2, ((LPCREATESTRUCT)lParam)->hInstance, 0);
		hCheckBox = CreateWindowEx(0, L"BUTTON", L"Wycz przycisk",
			WS_CHILD | WS_VISIBLE | BS_CHECKBOX, 
			5, 75, 150, 30, hwnd, 
			(HMENU)ID_CHECKBOX, ((LPCREATESTRUCT)lParam)->hInstance, 0);
		hEdit = CreateWindowEx(0, L"EDIT", L"Witaj wiecie!",
			WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL | ES_MULTILINE, 
			5, 110, 475, 380, hwnd, 
			(HMENU)ID_EDIT1, ((LPCREATESTRUCT)lParam)->hInstance, 0);
		hStatic = CreateWindowEx(0, L"STATIC", L"Pewien tekst",
			WS_CHILD | WS_VISIBLE, 5, 500, 200, 20, hwnd, 
			(HMENU)ID_STATIC, ((LPCREATESTRUCT)lParam)->hInstance, 0);
		
		hMenu = CreateMenu();
		hSubMenu = CreateMenu();
		AppendMenu(hSubMenu, MF_STRING, 101, L"&Nowy");
		AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);
		AppendMenu(hSubMenu, MF_STRING, 102, L"&Zamknij");
		AppendMenu(hMenu , MF_POPUP, (UINT_PTR)hSubMenu, L"Plik");
		
		hSubMenu = CreateMenu();
		AppendMenu(hSubMenu, MF_STRING, 201, L"&Kopiuj");
		AppendMenu(hSubMenu, MF_STRING, 202, L"&Wklej");
		AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hSubMenu, L"Edytuj");
		
		SetMenu(hwnd, hMenu);

		break;
	
	case WM_COMMAND :
		if (HIWORD(wParam) == BN_CLICKED)
		{
			if (LOWORD(wParam) == ID_BUTTON1)
			{
				HBRUSH g_hbBarva = CreateSolidBrush(RGB(rand()%255, rand()%255, rand()%255));
				SetClassLongPtr(hwnd, GCLP_HBRBACKGROUND, (LONG_PTR)g_hbBarva);
				InvalidateRect(hwnd, NULL, TRUE);
			}
			if (LOWORD(wParam) == ID_BUTTON2)
			{
				DWORD d = GetWindowTextLength(hEdit);
				LPSTR b = (LPSTR)GlobalAlloc(GPTR, 2* d + 1);
				GetWindowText(hEdit, (LPWSTR)b, d + 1);
				SetWindowText(hwnd, (LPCWSTR)b);
			}
			if (LOWORD(wParam) == ID_CHECKBOX)
			{
				LONG style = GetWindowLong(hButton2, GWL_STYLE);
				if (IsDlgButtonChecked(hwnd, ID_CHECKBOX))
				{
					CheckDlgButton(hwnd, ID_CHECKBOX, BST_UNCHECKED);
					style &= ~WS_DISABLED;
				}
				else
				{
					CheckDlgButton(hwnd, ID_CHECKBOX, BST_CHECKED);
					style |= WS_DISABLED;
				}
				SetWindowLong(hButton2, GWL_STYLE, style);
				InvalidateRect(hwnd, NULL, true);
			}
			if (LOWORD(wParam) == 101)	SendMessage(hEdit, WM_SETTEXT, 0, (LPARAM)L"");
			if (LOWORD(wParam) == 102)	SendMessage(hwnd, WM_CLOSE, 0, 0);
			if (LOWORD(wParam) == 201)	SendMessage(hEdit, WM_COPY, 0, 0);
			if (LOWORD(wParam) == 202)	SendMessage(hEdit, WM_PASTE, 0, 0);

		}
		break;

	case WM_MOUSEMOVE:
	{
		int xPos = LOWORD(lParam);
		int yPos = HIWORD(lParam);

		TCHAR buffor[100];
		wsprintf(buffor, L"x=%d y=%d", xPos, yPos);
		SendMessage(hStatic, WM_SETTEXT, NULL, (LPARAM)buffor);

		break;
	}

	case WM_CLOSE:
		if (MessageBox(NULL, L"Czy jeste pewny ? ", L"Zamknicie programu", MB_YESNO) == IDYES)
		{
			DestroyWindow(hwnd);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hwnd, msg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wc;
	HWND hwnd;
	MSG Msg;

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = 0;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)COLOR_GRAYTEXT;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = L"myWindowClass";
	wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

	if (!RegisterClassEx(&wc))
	{
		MessageBox(NULL, L"Window Registration Failed!", L"Error!",
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}




	hwnd = CreateWindowEx(
		0,
		L"myWindowClass",
		L"The title of my window",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, 500, 600,
		NULL, NULL, hInstance, NULL);

	if (hwnd == NULL)
	{
		MessageBoxA(NULL, "Window Creation Failed!", "Error!",
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	}







	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	while (GetMessage(&Msg, NULL, 0, 0) > 0)
	{
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
	}
	return 0;
}
